/**
 * \file    Mimic_String.hpp
 * \author  Silvan Murer
 * \date    02 August 2022
 *
 * \brief   String class of genSDK GF implementation, based on Mimic_Node
 */

#ifndef INC_FEATURES_MIMIC_STRING
#define INC_FEATURES_MIMIC_STRING

#include "features/Mimic_Node.hpp"

#include <memory>
#include <string>

namespace mimic {

class Mimic_String : public Mimic_Node
{
private:

public:
	Mimic_String();
	Mimic_String(GenApi_3_4::INode* node);
	virtual ~Mimic_String();

	virtual std::variant<int64_t, double, bool, std::string> getVariant(std::string name);
	virtual void setVariant(std::string name, std::variant<int64_t, double, bool, std::string> value);

	std::string getValue();
	void setValue(std::string value);
	
	//int64_t getMaxLengt();
};

} /* namespace mimic */

#endif
